Fixed bug with new SCALE variable setting for mencoder
[rip_dvd/.git] / rip_dvd
diff --git a/rip_dvd b/rip_dvd
index 4e37c54a9766a4250446430032fd79a6d512e7a9..9a6d47110ddd90d66c24633d998114f3f3f8d6bc 100755 (executable)
--- a/rip_dvd
+++ b/rip_dvd
 # Known Issues/Limitations:
 # - Mirror mode is always done in ISO mode
 #
-# Package Dependencies:
-# lsdvd dvdauthor gddrescue dvdbackup makexml tovid mencoder vlc mplayer genisoimage
+# Package Dependencies (apt-get install these for example):
+# lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
+#
+# Specific Executable (program) Dependencies (must be found in $PATH):
+# volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs
 #
 # Optional Dependencies:
 # lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
 #
 
-###############################################
-# Local Machine Settings - EDIT THIS SECTION
-
-# Specify the device path to the DVD drive
-dev=/dev/dvd2
-
-# Specify the path to the log directory 
-logdir=/var/log/ripdvd
-
-# Specify the path to the tmp rip directory
-tmpdir=/myth/video/DVDs/.ripdvd
-
-# Specify the email address to send job notifications to
-mailto=ajp@pippins.net
-
-# Setup the path to the tools needed by this ripper
-PATH=/etc/mythtv/bin:/usr/local/bin:/usr/sbin:/sbin:/usr/bin:.:$PATH
-
-# Use mplayer dumpstream to create the main VOB file
-# If set to 0, cat and other utils will be used to make it instead.
-# Using mplayer dumpstream is by far the best way to create the main VOB file
-# The only thing this doesn't work for are DVDs with the 99 title copy protection.
-# The script will autodetect these types of disks, and change this to 0 if necessary.
-# If this is set to 0, other methods will be employed to get the DVD VOB dump.
-use_mplayer_dumpstream=1
-
-# 2-channel AVI encoding audio bit rate
-audio_bitrate=224
-
-# If set to 1, this script will call another script to fill in the mythvideo metadata
-# If you don't use mythtv, set this option to 0. If you use mythtv, and have downloaded
-# the fill_mythvideo_metadata.pl script shown above, you can leave this option set to 1.
-fill_mythvideo_metadata=1
-
-# If the 99 titleset copy protection scheme is detected, trust the autodetection or abort.
-# The autodetection may work, but it probably won't in this case. Set to 0 by default. 
-# Override to 1 if you want the script to wing it, and hope it picks the right feature title.
-trust_feature_title_autodetect_when_uncertain=0
+##############################################################################
+# Local Machine Settings:
+# Sources both the "default" conf file tracked by GIT (rip_dvd.conf.dist)
+# and the local conf file created by each local machine (rip_dvd.conf)
+# Copy the rip_dvd.conf.dist file to rip_dvd.conf and edit the later.
+# This will allow you to override all the default values to meet your needs
+# in a way that won't get clobbered when you pull updates from my GIT repo.
+##############################################################################
+config="${0%/*}/rip_dvd.conf"
+[ -e "${config}.dist" ] && . ${config}.dist
+[ -e "${config}" ] && . ${config}
 
 ###############################################
 # Command line processing
@@ -67,7 +43,11 @@ typeset dvdname=""
 typeset debug=""
 typeset dest=""
 typeset isofile=""
+typeset vobfile=""
 typeset dvdpath=""
+typeset aspect=""
+typeset SCALE=""
+typeset CROP=""
 typeset -i keep_intermediate_files=0
 typeset -i make_final_dest_vob=0
 typeset -i make_final_dest_iso=0
@@ -83,7 +63,7 @@ typeset -i invalid_feature_title=0
 typeset -i feature_title_override=0
 typeset -i mplayer_dumpstream_incompatibility=0
 
-while (($#)) && getopts 2mvifkxht:n:d:b:s:t: opt "$@"
+while (($#)) && getopts 2mvifkxht:n:d:b:s:t:a: opt "$@"
 do
     case $opt in
         (n)     dvdname=$OPTARG;;
@@ -98,6 +78,7 @@ do
         (m)     mirror_mode=1;;
         (k)     keep_intermediate_files=1;;
         (t)     feature_title_override=$OPTARG;;
+       (a)     aspect=$OPTARG;;
         (w)     set -$opt;;
         (h)     show_usage=1;;
         (:)     echo >&2 "$0: $OPTARG requires a value"; errors=errors+1;;
@@ -112,9 +93,11 @@ function usage() {
     echo >&2 "Revision $REV"
     echo >&2 "Options:"
     echo >&2 "   -d <destdir>  Specify the destination directory to store the ripped DVD to"
-    echo >&2 "   -n <dvdname>  Specify what the name of the DVD is to process from $tmpdir"
-    echo >&2 "                 If it is a full path to a DVD folder, it will be ripped instead of $dev"
-    echo >&2 "                 This is optional. If not specified, the dvd will be pulled from $dev"
+    echo >&2 "   -n <dvdname>  Specify a path to a DVD folder or file to process:"
+    echo >&2 "                 1) If this option is not specified, the DVD will be ripped from $dev"
+    echo >&2 "                 2) If dvdname exists in $tmpdir, it will be ripped as a DVD instead of $dev"
+    echo >&2 "                 3) If dvdname is a full path to a DVD folder, it will be ripped as a DVD instead of $dev"
+    echo >&2 "                 4) If dvdname is a full path to an MPG2 file, it will be ripped as a DVD instead of $dev"
     echo >&2 "   -m            Make a mirror image of the DVD and save it as a DVD ISO file"
     echo >&2 "                 The default operation is non-mirror mode where only the main"
     echo >&2 "                 feature title will be ripped."
@@ -125,12 +108,15 @@ function usage() {
     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options"
     echo >&2 "   -s <size>     Set the target size of the AVI file in MB (ex: 700, 1000, etc)"
     echo >&2 "   -b <bitrate>  Set the bitrate desired in the AVI file in kbits/sec (ex: 1500, 2000 (default), etc)"    
+    echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -x mode)"
+    echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
+    echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
     echo >&2 "   -2            Use 2 channel MP3 audio encoding when making an AVI file (default is 6 channel AC3)"
     echo >&2 "   -k            Keep the intermediate files (good for debugging)"
     echo >&2 "                 In -x mode, run with this option to keep the original .VOB file"
     echo >&2 "                 By default, all intermediary files are deleted. Only the final image is kept"
     echo >&2 "   -t <title>    Specify the main feature title to pull from the DVD (only required if this script can't figure it out)"
-    echo >&2 "   -w            Set the sh Execute/Verbose flag"
+    echo >&2 "   -w            Set the sh Execute/Verbose flag (causes every command to be echoed)"
     echo >&2 ""
     exit 2
 }
@@ -146,8 +132,8 @@ if [ "$dest" == "" ]; then
   usage
 fi
 
-if ([ $target_bitrate -ne 0 ] || [ $target_size -ne 0 ]) && [ $make_final_dest_avi -ne 1 ]; then
-  echo "-E- You can't specify a bitrate in non AVI file mode. You must specify '-x' when using '-b' or '-s'" | tee -a $logfile
+if ([ $target_bitrate -ne 0 ] || [ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_avi -ne 1 ]; then
+  echo "-E- You can't specify a bitrate, target_size, or aspect in non AVI file mode. You must specify '-x' when using '-b' or '-s' or '-a'" | tee -a $logfile
   usage
 fi
 
@@ -170,6 +156,22 @@ if [ $mirror_mode -eq 1 ]; then
   fi
 fi
 
+# If the aspect ratio option was specified, set the scale variable appropriately for mencoder
+if [ "$aspect" != "" ]; then
+  echo "$aspect" | grep -q "x"
+  if [ $? == 0 ]; then
+    echo "-E- You must specify the aspect option with a value whose format is W:H"
+    exit 1
+  fi
+  echo "$aspect" | grep -q ":"
+  if [ $? != 0 ]; then
+    SCALE=",scale -zoom -xy $aspect"
+  else
+    SCALE=",scale=$aspect"
+  fi
+fi
+
+
 # Sanity Check - Key executables
 [[ ! -x `which lsdvd` ]] && echo "-E- missing dependency: lsdvd" && exit
 [[ ! -x `which volname` ]] && echo "-E- missing dependency: volname" && exit
@@ -200,24 +202,51 @@ else
     dvdpath="$dvdname"
     dvdname=`basename "$dvdname"`
     if [ -z "$dvdname" ]; then
-     fatal_and_exit "-E- Unable to extract dvdname from path: $dvdpath"
+     echo "-E- Unable to extract dvdname from path: $dvdpath"
+     exit 1
     fi
     if [ ! -d "$dvdpath/VIDEO_TS" ]; then
-      fatal_and_exit "-E- You must supply a full path to a valid DVD folder with this option"
+      echo "-E- You must supply a full path to a valid DVD folder with this option"
+      exit 1
+    fi
+  fi
+  # check to see if dvdname is a full path to an MPG2 (VOB) file
+  # if it is, set dvdname and vobfile appropriately
+  if [ -f "$dvdname" ]; then
+    vobfile="$dvdname"
+    dvdname=`basename "$dvdname"`
+    file "$vobfile" | grep -q "MPEG"
+    if [ $? == 0 ]; then
+      # It is a valid MPEG2 file, now strip the extension off our dvdname
+      dvdname=${dvdname%.[^.]*}
+    else 
+      echo "-E- Unsupported file type: $vobfile"
+      exit 1
     fi
   fi
   ripdvd=0
 fi
 
+# remove bad characters from the dvdname
+dvdname=${dvdname%.} # remove trailing '.' character
+
+# make a "safe" dvdname (remove special characters)
+safedvdname=`basename "$dvdname" | sed 's/[ !&*\\$?]/_/g'`
+
 # Make sure we have a non-empty dvdname
 if [ -z "$dvdname" ]; then
   echo "-E- unable to determine dvdname"
   exit 1
 fi
 
+# make sure our vobfile value is set
+if [ -z "$vobfile" ]; then
+  vobfile="$dest/$dvdname.VOB"
+fi
+
 # set up some variables to hold various logfiles
 logfile="$logdir/$dvdname.log"
-passlogfile="$tmpdir/divx2pass.log"
+passlogfile="$tmpdir/$safedvdname.log"
 ddrescuelog=`tempfile`
 dvdauthorlog=`tempfile`
 encodelog=`tempfile`
@@ -297,10 +326,7 @@ function make_dvd_iso_image {
     cat "$ddrescuelog" >> "$logfile"
   else
     # rip from a path instead
-    make_dvd_iso_image_from_folder "$dvdpath" "$isofile"
-    if [ ! -s "$isofile" ]; then
-      fatal_and_exit "-E- Unable to make an iso image from the DVD folder: $dvdpath"
-    fi
+    make_dvd_iso_image_from_folder "$dvdpath" "$isofile" 1
   fi
 }
 
@@ -308,14 +334,32 @@ function make_dvd_iso_image_from_folder {
   
   src="$1"
   dst="$2"
+  handle_error=$3
   
   echo "-> Creating ISO image of DVD video: $src -> $dst" | tee -a "$logfile"
 
   # make an iso image out of our directory
   echo "   mkisofs -dvd-video \"$src\" 2>> \"$dumplog\" | dd of=\"$dst\" obs=32k seek=0 > /dev/null 2>> $dumplog" >> "$logfile"
   mkisofs -dvd-video "$src" 2>> "$dumplog" | dd of="$dst" obs=32k seek=0 > /dev/null 2>> "$dumplog"
-  if [ $? != 0 ]; then
-    fatal_and_exit '-E- mkisofs -dvd-video "$src" | dd of="$dst" obs=32k seek=0 failed'
+
+  # set the audio languages from the iso if it exists and is non-zero in size
+  if [ -s "$dst" ]; then
+    get_feature_title "$dst"
+    get_audio_id_from_iso "$dst"
+  fi
+
+  # make sure we were able to create the iso image from the folder given to us
+  if [ ! -s "$dst" ] && [ $handle_error -eq 1 ]; then
+    echo "-> Unable to make an iso image from the DVD folder: $dvdpath"
+    echo "   Falling back to mplayer to create a main feature VOB from the folder instead: $dvdpath"
+    # remove the bad iso file
+    [[ -e "$dst" ]] && rm -f "$dst"
+    # get the feature title from the DVD folder
+    get_feature_title "$dvdpath"
+    # create our main VOB file from the ISO
+    create_main_vob_with_mplayer "$dvdpath" 
+    # get our audio id from the VOB file
+    get_audio_id_from_vob "$vobfile"
   fi
 }
 
@@ -362,6 +406,7 @@ function make_dvdauthor_folder_image {
 }
 
 function get_feature_title {
+  source="$1"
   # if a feature title was given on the command line, use it
   if [ $feature_title_override -ne 0 ]; then
     feature_title=$feature_title_override
@@ -371,7 +416,7 @@ function get_feature_title {
   if [ $ripdvd -eq 1 ]; then
     feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
   else 
-    feature_title=`lsdvd "$isofile" | awk '/Longest/ { print $NF }'`
+    feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
   fi
 }
 
@@ -391,6 +436,11 @@ function create_main_vob_with_cat {
 }
 
 function create_main_vob_with_mplayer {
+
+  # argument processing  
+  source="$1"
+  remove_dumplog=$2
+
   # make sure we have a valid feature title
   if [ $invalid_feature_title -eq 1 ] && [ $feature_title_override -eq 0 ]; then
     fatal_and_exit "-E- You must have a valid feature title to get the VOB via mplayer dumpstream. We can't determine the feature title for this DVD."
@@ -405,10 +455,9 @@ function create_main_vob_with_mplayer {
   fi
 
   # use mplayer to create the main VOB file
-  remove_dumplog=$1
-  echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $dest/$dvdname.VOB" | tee -a "$logfile"
-  echo "   mplayer $lang_opts -dumpstream -dumpfile \"$dest/$dvdname.VOB\" -dvd-device \"$isofile\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
-  mplayer $lang_opts -dumpstream -dumpfile "$dest/$dvdname.VOB" -dvd-device "$isofile" dvd://$feature_title > $dumplog 2>&1
+  echo "-> Using mplayer to dump the DVD feature title $feature_title to a VOB file directly: $vobfile" | tee -a "$logfile"
+  echo "   mplayer $lang_opts -dumpstream -dumpfile \"$vobfile\" -dvd-device \"$source\" dvd://$feature_title > $dumplog 2>&1" >> "$logfile"
+  mplayer $lang_opts -dumpstream -dumpfile "$vobfile" -dvd-device "$source" dvd://$feature_title > $dumplog 2>&1
   if [ $? != 0 ]; then
     cat $dumplog | grep -v "^A:" >> "$logfile"
     fatal_and_exit "-E- Mplayer Failed"
@@ -420,9 +469,10 @@ function create_main_vob_with_mplayer {
 function get_audio_id_from_iso {
   # Adjust our audio ID to find the english audio stream
   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
+  iso="$1"
   aidcheck=`tempfile`
   aid=128
-  mplayer -v -endpos 0 -dvd-device "$isofile" dvd://$feature_title > $aidcheck 2>&1
+  mplayer -v -endpos 0 -dvd-device "$iso" dvd://$feature_title > $aidcheck 2>&1
   grep -q "aid: $aid" $aidcheck
   while [ $? == 1 ] && [ $aid -lt 159 ]; do
     (( aid = aid + 1 ))
@@ -461,9 +511,10 @@ function get_crop_from_iso {
 function get_audio_id_from_vob {
   # Adjust our audio ID to find the english audio stream
   # This should be 128. However, if 128 is not there, pick the next one that incrementally is.
+  vob="$1"
   aidcheck=`tempfile`
   aid=128
-  mplayer -v -endpos 0 "$tmpdir/$dvdname.VOB" > $aidcheck 2>&1
+  mplayer -v -endpos 0 "$vob" > $aidcheck 2>&1
   grep -q "Found audio stream: $aid" $aidcheck
   while [ $? == 1 ] && [ $aid -lt 159 ]; do
     (( aid = aid + 1 ))
@@ -499,7 +550,7 @@ function check_vob_for_corrupted_start {
   [[ -e "$badvobcheck" ]] && rm -f "$badvobcheck";
 
   # cat the giant VOB into mencoder to create a playable VOB file
-  cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$dest/$dvdname.VOB" >> "$logfile" 2>&1
+  cat "$tmpdir/$dvdname.VOB" | mencoder -ss $skip -quiet $lang_opts -of mpeg -mpegopts format=dvd:tsaf -oac copy -ovc copy - -o "$vobfile" >> "$logfile" 2>&1
   if [ $? != 0 ]; then
     fatal_and_exit "-E- Mencoder Failed"
   fi
@@ -513,14 +564,14 @@ function check_vob_for_completeness {
   # detect this by seeing how much smaller the dst vob is from the src vob.
   MAX_FILESIZE_DELTA_PERCENT=70
   SRC_VOB_FILESIZE=$(stat -c%s "$tmpdir/$dvdname.VOB")
-  DST_VOB_FILESIZE=$(stat -c%s "$dest/$dvdname.VOB")
+  DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
   FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
   if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
     echo "-> Detected bad VOB size copy protection after processing concatenated VOB file." | tee -a "$logfile"
-    create_main_vob_with_mplayer
+    create_main_vob_with_mplayer "$isofile"
     [[ -e "$dumplog" ]] && rm -f $dumplog
-    DST_VOB_FILESIZE=$(stat -c%s "$dest/$dvdname.VOB")
+    DST_VOB_FILESIZE=$(stat -c%s "$vobfile")
     FILESIZE_DELTA=`echo "scale=2; $DST_VOB_FILESIZE / $SRC_VOB_FILESIZE * 100" | bc | awk -F '.' '{ print $1 }'`
     if [ $FILESIZE_DELTA -lt $MAX_FILESIZE_DELTA_PERCENT ]; then
       fatal_and_exit "-E- This DVD has a copy protection scheme we can't work around. Sorry.\n    I recommend using another ripping mode like '-m' or '-i'"
@@ -540,7 +591,7 @@ function check_vob_for_too_many_video_packets {
   if [ $? == 0 ]; then
     # Try one other way to get the VOB using mplayer directly to rip the feature titleset.
     echo "-> Detected corrupt audio stream copy protection after processing concatenated VOB file." | tee -a "$logfile"
-    create_main_vob_with_mplayer
+    create_main_vob_with_mplayer "$isofile"
     grep -q "Too many video packets in the buffer:" $dumplog
     if [ $? == 0 ]; then
       [[ -e "$dumplog" ]] && rm -f $dumplog
@@ -559,14 +610,14 @@ function check_vob_for_a52_crc_errors {
   MAX_ERRORS=10
   ENDPOS=120
   echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
-  mplayer -endpos $ENDPOS -ao null -vo null "$dest/$dvdname.VOB" > $dumplog 2>&1
+  mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
   cat $dumplog | grep -v "^A:" >> "$logfile"
   errors=`grep "a52: CRC check failed" $dumplog | wc | awk '{ print $1 }'`
   if [ $errors -gt $MAX_ERRORS ]; then
     echo "-> Detected a52 audio stream CRC errors copy protection after processing concatenated VOB file." | tee -a "$logfile"
-    create_main_vob_with_mplayer
+    create_main_vob_with_mplayer "$isofile"
     echo "-> Checking for a52 audio stream CRC errors" | tee -a "$logfile"
-    mplayer -endpos $ENDPOS -ao null -vo null "$dest/$dvdname.VOB" > $dumplog 2>&1
+    mplayer -endpos $ENDPOS -ao null -vo null "$vobfile" > $dumplog 2>&1
     if [ $? != 0 ]; then
       cat $dumplog | grep -v "^A:" >> "$logfile"
       fatal_and_exit "-E- Mplayer Failed"
@@ -583,7 +634,7 @@ function check_vob_for_a52_crc_errors {
 function calculate_bitrate_from_target_size {
   # determine what our bitrate needs to be if a target size was specified instead
   if [ $target_size -ne 0 ]; then
-    vob_length=`mplayer -identify -v "$dest/$dvdname.VOB" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
+    vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
     ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
     echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
   fi
@@ -643,7 +694,7 @@ function check_for_mplayer_dumpstream_incompatibility {
 
   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
 
-  if [ ! -e "$dest/$dvdname.VOB" ]; then
+  if [ ! -e "$vobfile" ]; then
     # mplayer dumpstream does not work on DVDs that obscure the feature title.
     # A DVD that has 99 titles, where the longest title isn't the main feature
     # breaks mplayer dumpstream. We have to fallback to using dvdbackup to figure
@@ -659,6 +710,7 @@ function check_for_mplayer_dumpstream_incompatibility {
       if [ $trust_feature_title_autodetect_when_uncertain -eq 0 ]; then
         echo "-E- Unable to determine the feature title due to the 99 title copy protection scheme" | tee -a "$logfile"
         echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
+        echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"
         invalid_feature_title=1
       else 
         echo "    Falling back to non mplayer dumpstream methods to copy the DVD" | tee -a "$logfile"
@@ -675,9 +727,9 @@ function check_for_mplayer_dumpstream_incompatibility {
   # This can be detected by telling mplayer to parse the VOB file by copying its audio
   # video streams to a dummy output file (/dev/null). Do that here to check for that 
   # problem before continuing.
-  if [ -e "$dest/$dvdname.VOB" ]; then
+  if [ -e "$vobfile" ]; then
     mplayer_opts="-quiet -ofps 30000/1001 -ffourcc DIVX -oac copy -ovc copy"
-    mencoder $mplayer_opts "$dest/$dvdname.VOB" -o "/dev/null" > $dumplog 2>&1
+    mencoder $mplayer_opts "$vobfile" -o "/dev/null" > $dumplog 2>&1
     grep -q "Too many audio packets in the buffer" $dumplog
     if [ $? == 0 ]; then
       echo "-> The VOB dumped by mplayer is invalid. Falling back to non mplayer dumpstream to copy the DVD" | tee -a "$logfile"
@@ -779,24 +831,21 @@ if [ $mirror_mode -eq 0 ]; then
   # Rip image from DVD path
   if [ -n "$dvdpath" ]; then
     echo "-> Ripping DVD $dvdpath to $dest" | tee -a "$logfile"
-    make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso"
-    if [ ! -s "$tmpdir/$dvdname.iso" ]; then
-      fatal_and_exit "-E- Unable to make an iso image from the DVD folder: $dvdpath"
-    fi
+    make_dvd_iso_image_from_folder "$dvdpath" "$tmpdir/$dvdname.iso" 1
   fi
 
   # make sure our isofile value is set
   if [ -z "$isofile" ]; then
     isofile="$tmpdir/$dvdname.iso"
   fi
-   
+     
   if [ $make_final_dest_vob -eq 1 ] || [ $make_final_dest_avi -eq 1 ]; then
 
-    if [ ! -e "$dest/$dvdname.VOB" ]; then
-      echo "-> Creating DVD video $dest/$dvdname.VOB" | tee -a "$logfile"
+    if [ ! -e "$vobfile" ]; then
+      echo "-> Creating DVD video $vobfile" | tee -a "$logfile"
       
       # get the feature title from the ISO
-      get_feature_title
+      get_feature_title "$isofile"
  
       # get the crop value from the ISO
       get_crop_from_iso
@@ -808,10 +857,10 @@ if [ $mirror_mode -eq 0 ]; then
       if [ $use_mplayer_dumpstream -eq 1 ]; then 
 
         # get our audio id from the ISO file
-        get_audio_id_from_iso
+        get_audio_id_from_iso "$isofile"
 
         # create our main VOB file from the ISO
-        create_main_vob_with_mplayer        
+        create_main_vob_with_mplayer "$isofile"
      
         # remove the intermediate VOB file
         remove_intermediate_vob_file
@@ -831,7 +880,7 @@ if [ $mirror_mode -eq 0 ]; then
         create_main_vob_with_cat
 
         # get our audio id from the VOB file
-        get_audio_id_from_vob
+        get_audio_id_from_vob "$tmpdir/$dvdname.VOB"
   
         # check for corrupted VOB start
         check_vob_for_corrupted_start
@@ -854,7 +903,7 @@ if [ $mirror_mode -eq 0 ]; then
       remove_intermediate_iso_file
 
     else
-      echo "-> Skipping VOB creation. VOB DVD video already exists: $dest/$dvdname.VOB" | tee -a "$logfile"
+      echo "-> Skipping VOB creation. VOB DVD video already exists: $vobfile" | tee -a "$logfile"
     fi
 
     # transcode the DVD
@@ -871,8 +920,8 @@ if [ $mirror_mode -eq 0 ]; then
       # Edit these as needed to suite your needs
       mencoder_general_opts="-quiet $lang_opts -passlogfile $passlogfile"
       mencoder_output_opts="-ofps 30000/1001 -ffourcc DIVX"
-      mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP"
-      mencoder_video_encoder_opts="-ovc xvid -xvidencopts pass=%PASS:chroma_opt:vhq=4:bvhq=1:quant_type=mpeg:bitrate=$target_bitrate:autoaspect:threads=2"
+      mencoder_video_filter_opts="-vf pullup,softskip,hqdn3d=2:1:2$CROP$SCALE"
+      mencoder_video_encoder_opts="-ovc xvid -xvidencopts pass=%PASS:chroma_opt:vhq=4:bvhq=1:quant_type=mpeg:bitrate=$target_bitrate:autoaspect:threads=$mencoder_threads"
 
       # There are a number of different ways to encode 6 channel audio.
       # I've loaded 3 different ways into the mencoder_audioch_opts.
@@ -915,8 +964,8 @@ if [ $mirror_mode -eq 0 ]; then
         for CH_OPTS in "${mencoder_audioch_opts[@]}"; 
         do
           echo -e "   Encoding pass $PASS"
-          echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$dest/$dvdname.VOB\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
-          mencoder $CH_OPTS $mencoder_opts_for_pass "$dest/$dvdname.VOB" -o "$output_file" > $encodelog 2>&1
+          echo -e "\n   Encoding pass $PASS: mencoder $CH_OPTS $mencoder_opts_for_pass \"$vobfile\" -o \"$output_file\" >> $encodelog 2>&1" >> "$logfile"
+          mencoder $CH_OPTS $mencoder_opts_for_pass "$vobfile" -o "$output_file" > $encodelog 2>&1
           mencoder_retval=$? 
           grep -q "\[channels\] Invalid" $encodelog
           if [ $? != 0 ]; then     
@@ -933,17 +982,17 @@ if [ $mirror_mode -eq 0 ]; then
       done
 
       if [ $keep_intermediate_files -eq 0 ] && [ $make_final_dest_vob -eq 0 ]; then
-        [[ -e "$dest/$dvdname.VOB" ]] && rm -f "$dest/$dvdname.VOB";
+        [[ -e "$vobfile" ]] && rm -f "$vobfile";
         [[ -e "$passlogfile" ]] && rm -f "$passlogfile";
       else
-        echo "-> Keeping VOB file: $dest/$dvdname.VOB" | tee -a "$logfile"
+        echo "-> Keeping VOB file: $vobfile" | tee -a "$logfile"
         echo "-> Keeping mencoder 2pass logfile: $passlogfile"
       fi
     fi
 
   # add this video data to the mythtv DB
   [ $make_final_dest_avi -eq 1 ] && fill_mythvideo_metadata "$dest/$dvdname.avi" 
-  [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$dest/$dvdname.VOB
+  [ $make_final_dest_vob -eq 1 ] && fill_mythvideo_metadata "$vobfile
     
   else
 
@@ -971,7 +1020,7 @@ if [ $mirror_mode -eq 0 ]; then
   if [ $make_final_dest_iso -eq 1 ]; then
 
     # make an iso image out of our directory
-    make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso"
+    make_dvd_iso_image_from_folder "$dest/$dvdname" "$dest/$dvdname.iso" 0
    
     # If the mkisofs was unable to make a .iso file for us, don't remove the DVD directory 
     if [ -s "$dest/$dvdname.iso" ]; then